

===================== parser output ===============================

let x  = 17
in 
   let rec f  y = 
      let rec g  z = ((x + y) + z)
      in g
   in 
      let first  = (f 21)
      in 
         let second  = (f 88)
         in 
            let result  = ((first 99) + (second 44))
            in (print_int result)

===================== typing output ===============================

let x  : int = 17
in 
   let rec f  : (int) -> (int) -> int y : int = 
      let rec g  : (int) -> int z : int = ((x + y) + z)
      in g
   in 
      let first  : (int) -> int = (f 21)
      in 
         let second  : (int) -> int = (f 88)
         in 
            let result  : int = ((first 99) + (second 44))
            in (print_int result)

===================== knormal output ===============================

let x  : int = 17 in

let f  : (int) -> (int) -> inty : int = 
   let g  : (int) -> intz : int = 
      let Ti7  : int = (x + y) in
      (Ti7 + z)
   in g
in 
   let first  : (int) -> int = let Ti1  : int = 21 in
   (f Ti1) in
   
   let second  : (int) -> int = let Ti2  : int = 88 in
   (f Ti2) in
   
   let result  : int = let Ti4  : int = let Ti3  : int = 99 in
   (first Ti3) in
   
   let Ti6  : int = let Ti5  : int = 44 in
   (second Ti5) in
   (Ti4 + Ti6) in
   EXTERN(print_int result)

===================== alpha output ===============================

let x.8  : int = 17 in

let f.9  : (int) -> (int) -> inty.10 : int = 
   let g.20  : (int) -> intz.21 : int = 
      let Ti7.22  : int = (x.8 + y.10) in
      (Ti7.22 + z.21)
   in g.20
in 
   let first.11  : (int) -> int = let Ti1.19  : int = 21 in
   (f.9 Ti1.19) in
   
   let second.12  : (int) -> int = let Ti2.18  : int = 88 in
   (f.9 Ti2.18) in
   
   let result.13  : int = let Ti4.14  : int = let Ti3.17  : int = 99 in
   (first.11 Ti3.17) in
   
   let Ti6.15  : int = let Ti5.16  : int = 44 in
   (second.12 Ti5.16) in
   (Ti4.14 + Ti6.15) in
   EXTERN(print_int result.13)

===================== simplify output ===============================

let x.8  : int = 17 in

let f.9  : (int) -> (int) -> inty.10 : int = 
   let g.20  : (int) -> intz.21 : int = 
      let Ti7.22  : int = (x.8 + y.10) in
      (Ti7.22 + z.21)
   in g.20
in 
   let Ti1.19  : int = 21 in
   
   let first.11  : (int) -> int = (f.9 Ti1.19) in
   
   let Ti2.18  : int = 88 in
   
   let second.12  : (int) -> int = (f.9 Ti2.18) in
   
   let Ti3.17  : int = 99 in
   
   let Ti4.14  : int = (first.11 Ti3.17) in
   
   let Ti5.16  : int = 44 in
   
   let Ti6.15  : int = (second.12 Ti5.16) in
   
   let result.13  : int = (Ti4.14 + Ti6.15) in
   EXTERN(print_int result.13)

===================== closure output ===============================
let LABEL(g.20) [x.8 : int, y.10 : int] z.21 : int = 
   let Ti7.22  : int = (x.8 + y.10) in
   (Ti7.22 + z.21)
in

let LABEL(f.9) [x.8 : int] y.10 : int = 
   let closure g.20  : (int) -> int = ( LABEL(g.20); [x.8, y.10] )
   in g.20
in

let x.8  : int = 17 in

let closure f.9  : (int) -> (int) -> int = ( LABEL(f.9); [x.8] )
in 
   let Ti1.19  : int = 21 in
   
   let first.11  : (int) -> int = APPLY_CLOSURE(f.9 Ti1.19) in
   
   let Ti2.18  : int = 88 in
   
   let second.12  : (int) -> int = APPLY_CLOSURE(f.9 Ti2.18) in
   
   let Ti3.17  : int = 99 in
   
   let Ti4.14  : int = APPLY_CLOSURE(first.11 Ti3.17) in
   
   let Ti5.16  : int = 44 in
   
   let Ti6.15  : int = APPLY_CLOSURE(second.12 Ti5.16) in
   
   let result.13  : int = (Ti4.14 + Ti6.15) in
   APPLY_DIRECT(LABEL(min_caml_print_int) result.13)

===================== virtual  output ===============================
==== Data Segment =======
==== Function Declarations =======

LABEL(g.20) (arg=(z.21), farg=())

LET(y.10, ld(%o5, 8), 
   LET(x.8, ld(%o5, 4), 
      LET(Ti7.22, add(x.8, y.10), 
         ANSWER(add(Ti7.22, z.21)))))

LABEL(f.9) (arg=(y.10), farg=())

LET(x.8, ld(%o5, 4), 
   LET(g.20, mov(%i1), 
      LET(%i1, add(%i1, 16), 
         LET(l.25, set(LABEL(g.20)), 
            LET(Tu26, st(l.25, g.20, 0), 
               LET(Tu24, st(y.10, g.20, 8), 
                  LET(Tu23, st(x.8, g.20, 4), 
                     ANSWER(mov(g.20)))))))))
==== Expression =======

LET(x.8, set(17), 
   LET(f.9, mov(%i1), 
      LET(%i1, add(%i1, 8), 
         LET(l.28, set(LABEL(f.9)), 
            LET(Tu29, st(l.28, f.9, 0), 
               LET(Tu27, st(x.8, f.9, 4), 
                  LET(Ti1.19, set(21), 
                     LET(first.11, CallClosure(f.9, args=(Ti1.19), farg=()), 
                        LET(Ti2.18, set(88), 
                           LET(second.12, CallClosure(f.9, args=(Ti2.18), farg=()), 
                              LET(Ti3.17, set(99), 
                                 LET(Ti4.14, CallClosure(first.11, args=(Ti3.17), farg=()), 
                                    LET(Ti5.16, set(44), 
                                       LET(Ti6.15, CallClosure(second.12, args=(Ti5.16), farg=()), 
                                          LET(result.13, add(Ti4.14, Ti6.15), 
                                             ANSWER(CallDirect(LABEL(min_caml_print_int), args=(result.13), farg=())))))))))))))))))


=====================  simm13  output ===============================
==== Data Segment =======
==== Function Declarations =======

LABEL(g.20) (arg=(z.21), farg=())

LET(y.10, ld(%o5, 8), 
   LET(x.8, ld(%o5, 4), 
      LET(Ti7.22, add(x.8, y.10), 
         ANSWER(add(Ti7.22, z.21)))))

LABEL(f.9) (arg=(y.10), farg=())

LET(x.8, ld(%o5, 4), 
   LET(g.20, mov(%i1), 
      LET(%i1, add(%i1, 16), 
         LET(l.25, set(LABEL(g.20)), 
            LET(Tu26, st(l.25, g.20, 0), 
               LET(Tu24, st(y.10, g.20, 8), 
                  LET(Tu23, st(x.8, g.20, 4), 
                     ANSWER(mov(g.20)))))))))
==== Expression =======

LET(x.8, set(17), 
   LET(f.9, mov(%i1), 
      LET(%i1, add(%i1, 8), 
         LET(l.28, set(LABEL(f.9)), 
            LET(Tu29, st(l.28, f.9, 0), 
               LET(Tu27, st(x.8, f.9, 4), 
                  LET(Ti1.19, set(21), 
                     LET(first.11, CallClosure(f.9, args=(Ti1.19), farg=()), 
                        LET(Ti2.18, set(88), 
                           LET(second.12, CallClosure(f.9, args=(Ti2.18), farg=()), 
                              LET(Ti3.17, set(99), 
                                 LET(Ti4.14, CallClosure(first.11, args=(Ti3.17), farg=()), 
                                    LET(Ti5.16, set(44), 
                                       LET(Ti6.15, CallClosure(second.12, args=(Ti5.16), farg=()), 
                                          LET(result.13, add(Ti4.14, Ti6.15), 
                                             ANSWER(CallDirect(LABEL(min_caml_print_int), args=(result.13), farg=())))))))))))))))))


===================== RegAlloc output ===============================
==== Data Segment =======
==== Function Declarations =======

LABEL(g.20) (arg=(%i2), farg=())

LET(%i3, ld(%o5, 8), 
   LET(%i4, ld(%o5, 4), 
      LET(%i3, add(%i4, %i3), 
         ANSWER(add(%i3, %i2)))))

LABEL(f.9) (arg=(%i2), farg=())

LET(%i3, ld(%o5, 4), 
   LET(%i4, mov(%i1), 
      LET(%i1, add(%i1, 16), 
         LET(%i5, set(LABEL(g.20)), 
            LET(%g0, st(%i5, %i4, 0), 
               LET(%g0, st(%i2, %i4, 8), 
                  LET(%g0, st(%i3, %i4, 4), 
                     ANSWER(mov(%i4)))))))))
==== Expression =======

LET(%i2, set(17), 
   LET(%o5, mov(%i1), 
      LET(%g0, save(%o5, f.9), 
         LET(%i1, add(%i1, 8), 
            LET(%i3, set(LABEL(f.9)), 
               LET(%g0, st(%i3, %o5, 0), 
                  LET(%g0, st(%i2, %o5, 4), 
                     LET(%i2, set(21), 
                        LET(%i2, CallClosure(%o5, args=(%i2), farg=()), 
                           LET(%i2, mov(%i2), 
                              LET(%g0, save(%i2, first.11), 
                                 LET(%i2, set(88), 
                                    LET(%o5, restore(f.9), 
                                       LET(%i2, CallClosure(%o5, args=(%i2), farg=()), 
                                          LET(%i2, mov(%i2), 
                                             LET(%g0, save(%i2, second.12), 
                                                LET(%i2, set(99), 
                                                   LET(%o5, restore(first.11), 
                                                      LET(%i2, CallClosure(%o5, args=(%i2), farg=()), 
                                                         LET(%i2, mov(%i2), 
                                                            LET(%g0, save(%i2, Ti4.14), 
                                                               LET(%i2, set(44), 
                                                                  LET(%o5, restore(second.12), 
                                                                     LET(%i2, CallClosure(%o5, args=(%i2), farg=()), 
                                                                        LET(%i2, mov(%i2), 
                                                                           LET(%i3, restore(Ti4.14), 
                                                                              LET(%i2, add(%i3, %i2), 
                                                                                 ANSWER(CallDirect(LABEL(min_caml_print_int), args=(%i2), farg=())))))))))))))))))))))))))))))


===================== Emit output ===============================
